rollout LazyMap "LazyMap" width:184 height:605
(
	
		
	/*-----------------------------------------------------------------
	UI elements
	-----------------------------------------------------------------*/
	
	
	groupBox grpMove "Move (scene units)" pos:[8,10] width:160 height:90
	spinner spnMX "X: " pos:[16,28] width:88 height:16 range:[0,100000,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	spinner spnMY "Y: " pos:[16,52] width:88 height:16 range:[0,100000,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	spinner spnMZ "Z: " pos:[16,76] width:88 height:16 range:[0,100000,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	checkButton ckbMoveLock "XYZ" pos:[112,28] width:48 height:16 tooltip: "Locks all the values to the value of the X spinner."
	checkButton ckbMoveToggle "ON" pos:[112,52] width:48 height:40 checked:true tooltip: "Enables or disables the move transform."
	groupBox grpRotate "Rotate (degrees)" pos:[8,106] width:160 height:90
	spinner spnRX "X: " pos:[16,124] width:88 height:16 range:[0,360,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	spinner spnRY "Y: " pos:[16,148] width:88 height:16 range:[0,360,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	spinner spnRZ "Z: " pos:[16,172] width:88 height:16 range:[0,360,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	checkButton ckbRotateLock "XYZ" pos:[112,124] width:48 height:16 tooltip: "Locks all the values to the value of the X spinner."
	checkButton ckbRotateToggle "OFF" pos:[112,148] width:48 height:40 tooltip: "Enables or disables the rotate transform."
	groupBox grpScale "Scale (percent)" pos:[8,202] width:160 height:90
	spinner spnSX "X: " pos:[16,220] width:88 height:16 range:[0,100,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	spinner spnSY "Y: " pos:[16,244] width:88 height:16 range:[0,100,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	spinner spnSZ "Z: " pos:[16,268] width:88 height:16 range:[0,100,0] tooltip: "The value acts both as min and max value.\n Ie, a value of 1 will randomize between -1\nand 1."
	checkButton ckbScaleLock "XYZ" pos:[112,220] width:48 height:16 tooltip: "Locks all the values to the value of the X spinner."
	checkButton ckbScaleToggle "OFF" pos:[112,244] width:48 height:40 tooltip:"Enables or disables the scale transform."
	checkbox chkSkipDisabled "Skip disabled" pos:[8,328] width:80 height:16 tooltip: "If checked, disabled UVW modifiers won't be affected."
	checkbox chkAffectChannel "Affect channel:" pos:[8,304] width:100 height:16 tooltip: "If checked, only the modifiers with the selected channel will be affected."
	spinner spnChannel "" pos:[112,304] width:56 height:16 type:#integer enabled:false
	checkbox chkMakeUnique "Make unique" pos:[8,352] width:80 height:16 tooltip: "If checked, all the UVW modifiers will be made unique before any transforms are applied."
	Button makeItSo "APPLY" pos: [96,328] width:72 height:40
	
	groupbox grpSpacer "" pos: [8,374] width:160 height:4
	
	groupBox grpQR "90° Rotate:" pos:[8,388] width:76 height:98
	Button btnQuickRotateX "X" pos: [16,406] width:60 height:20 tooltip: "Rotates the gizmo by 90° along the X axis."
	Button btnQuickRotateY "Y" pos: [16,432] width:60 height:20 tooltip: "Rotates the gizmo by 90° along the Y axis."
    Button btnQuickRotateZ "Z" pos: [16,458] width:60 height:20 tooltip: "Rotates the gizmo by 90° along the Z axis."
	
	groupBox grpAlign "Align:" pos:[92,388] width:76 height:98
	Button btnAlignX "X" pos: [100,406] width:60 height:20 tooltip: "Aligns the gizmo's X axis to the object's local Z axis."
	Button btnAlignY "Y" pos: [100,432] width:60 height:20 tooltip: "Aligns the gizmo's Y axis to the object's local Z axis."
    Button btnAlignZ "Z" pos: [100,458] width:60 height:20 tooltip: "Aligns the gizmo's Z axis to the object's local Z axis."
	
	groupbox grpSpacer2 "" pos: [8,490] width:160 height:4
	
	Button btnRevertAll "Revert"  pos:[8,504] width:160 height:30 tooltip: "Reverts all the changes LazyMap has done.\n\nPlease note: If you undo this action, the LazyMap data stored in the objects will be erased, and a subsequent Revert will consider the state after the undo as the new starting state."
    
	groupbox grpSpacer3 "" pos: [8,538] width:160 height:4
	
	
	Button btnDockLeft "<" pos:[8,552] width:16 height:16 tooltip: "Dock LazyMap rollout left."
	Button btnFloat "" pos:[28,552] width:16 height:16 tooltip:"Undock LazyMap rollout."
	Button btnDockRight ">" pos:[48,552] width:16 height:16 tooltip: "Dock LazyMap rollout right."
	
	Button btnExit "Exit" pos: [120,552] width:48 height:16
	label  authorLbl "(c) Hrvoje Cop/Studio Niskota 2015" pos:[3,576]

	
	/*-----------------------------------------------------------------
	Functions
	-----------------------------------------------------------------*/
	
	fn moveGizmo theGiz =
		(
			randX = random  -(spnMX.value) spnMX.value
			if ckbMoveLock.state == true then
				(
					randY = random -(spnMX.value) spnMX.value
					randZ = random -(spnMX.value) spnMX.value
				)
			else 
				(
					randY = random -(spnMY.value) spnMY.value
					randZ = random -(spnMZ.value) spnMZ.value
				)
			newPos = [randX, randY, randZ]
			theGiz.position += newPos
		)
	
	fn rotateGizmo theGiz =
		(
			randX = random  -(spnRX.value) spnRX.value
			if ckbRotateLock.state == true then
				(
					randY = random -(spnRX.value) spnRX.value
					randZ = random -(spnRX.value) spnRX.value
				)
			else 
				(
					randY = random -(spnRY.value) spnRY.value
					randZ = random -(spnRZ.value) spnRZ.value
				)
			currentMatrix = theGiz.transform
			preRotate currentMatrix (eulertoquat (eulerAngles randX randY randZ))
			theGiz.transform = currentMatrix
		)
	
	fn scaleGizmo theGiz =
		(
			randX = (random  -(spnSX.value) spnSX.value) / 100
				if ckbRotateLock.state == true then
					(
						randY = (random -(spnSX.value) spnSX.value) / 100
						randZ = (random -(spnRX.value) spnRX.value) / 100
 					)
				else 
					(
						randY = (random -(spnSY.value) spnSY.value) / 100
						randZ = (random -(spnSZ.value) spnSZ.value) / 100
					)
				newScale = [randX, randY, randZ]	
				theGiz.scale +=  newScale
		)
	
	fn transformGizmo theModifier =
		(
			if  (chkSkipDisabled.checked==true and theModifier.enabled == true) or chkSkipDisabled.checked == false then
			(	
				if (chkAffectChannel.checked == true and theModifier.mapChannel == spnChannel.value) or chkAffectChannel.checked == false then
				(
					if ckbMoveToggle.state == true do moveGizmo theModifier.gizmo
					if ckbRotateToggle.state == true do rotateGizmo theModifier.gizmo
					if ckbScaleToggle.state == true do scaleGizmo theModifier.gizmo
				)
			)
		)
		
	fn makeModifierUnique theObj theMod =
		(
			if InstanceMgr.CanMakeModifiersUnique theObj theMod == true then InstanceMgr.MakeModifiersUnique theObj theMod #individual
		)

	fn checkForLazyMapData theMod =
		(
			if (getAppData theMod 7666) != undefined then 
				(
					tempData= StringStream (getAppData theMod 7666)
					testString = readValue tempData
					if testString == "LazyMap" then
						(

							free tempData
							return true
						)
					else 
						(
						  messagebox "Data conflict with some other script!\nLazyMap uses AppData ID 7666.\nPlease contact me at cop.hrvoje@gmail.com" title:"LazyMap Error!" 
						  free tempData
						  return false
						)					
				)
			else 
				(
					return false
				)
			
		)
		
	fn writeLazyMapData theMod =
		(
			if checkForLazyMapData theMod  == false then
									(
										tempData = stringStream ""
										print "LazyMap" to: tempData
										print theMod.axis to: tempData
										print theMod.length to: tempData
										print theMod.width to: tempData
										print theMod.height to: tempData
										print theMod.gizmo.transform to: tempData
										setAppData theMod 7666 tempData
										free tempData
									)
		)
		
	
		
	fn doLazyMap taskSwitch =
		(
			undo "LazyMap" on
			(
				clearListener()
				theSelection = selection as array
				if theSelection.count != 0 do
				(
					for theObj in theSelection do
					( 					
						for theMod in theObj.modifiers do
						(
							if classOf  theMod ==  Uvwmap then
							(
								case taskSwitch of
								(
								"rotateX":
									(
									writeLazyMapData theMod
									theGiz=theMod.gizmo
									currentMatrix = theGiz.transform
									preRotate currentMatrix (eulertoquat (eulerAngles 90 0 0))
									theGiz.transform = currentMatrix
									)
									
								"rotateY":
									(
									writeLazyMapData theMod
									theGiz=theMod.gizmo
									currentMatrix = theGiz.transform
									preRotate currentMatrix (eulertoquat (eulerAngles 0 90 0))
									theGiz.transform = currentMatrix
									)
									
								"rotateZ":
									(
									writeLazyMapData theMod
									theGiz=theMod.gizmo
									currentMatrix = theGiz.transform
									preRotate currentMatrix (eulertoquat (eulerAngles 0 0 90))
									theGiz.transform = currentMatrix
									)
									
								"randomize":
									(
									writeLazyMapData theMod
									if chkMakeUnique.checked == true then makeModifierUnique theObj theMod
									transformGizmo theMod
									)
								
								"alignX":
									(
									 writeLazyMapData theMod
									 theMod.axis = 0
									)
								
								"alignY":
									(
									 writeLazyMapData theMod
									 theMod.axis = 1
									)
								
								"alignZ":
									(
									 writeLazyMapData theMod
									 theMod.axis = 2
									)	
									
								"revert":
									(
									if checkForLazyMapData theMod == true do
										(
											tempData = StringStream (getAppData theMod 7666)
											seek tempData 0
											testString = readValue tempData
											theMod.axis = readValue tempData 
											theMod.length = readValue tempData 
											theMod.width = readValue tempData 
											theMod.height = readValue tempData 
											theMod.gizmo.transform = readValue tempData
											deleteAppData theMod 7666
											free tempData
										)
									)
									
								"fit":
									(
										--coming sometime in the future
									)
								)	
							)
						)
					)
				)
			)
		)
	
	/*-----------------------------------------------------------------
	Button Event Handlers
	-----------------------------------------------------------------*/
	
	on chkAffectChannel changed theState do 
		(
			if theState == true then spnChannel.enabled = true
			else spnChannel.enabled = false
		)
	
	on ckbMoveToggle changed theState do
		(
			if theState == true then ckbMoveToggle.caption = "ON"
			else ckbMoveToggle.caption = "OFF"
		)
		
	on ckbRotateToggle changed theState do
		(
			if theState == true then ckbRotateToggle.caption = "ON"
			else ckbRotateToggle.caption = "OFF"
		)
	
	on ckbScaleToggle changed theState do
		(
			if theState == true then ckbScaleToggle.caption = "ON"
			else ckbScaleToggle.caption = "OFF"
		)
		
	on ckbMoveLock changed theState do
		(
			if theState == true then 
				(	
					spnMY.enabled=false
					spnMZ.enabled=false
				)
	        else
				(	
					spnMY.enabled=true
					spnMZ.enabled=true
				)
		)
		
	on ckbRotateLock changed theState do
		(
			if theState == true then 
				(	
					spnRY.enabled=false
					spnRZ.enabled=false
				)
	        else
				(	
					spnRY.enabled=true
					spnRZ.enabled=true
				)
		)
			
	on ckbScaleLock changed theState do
		(
			if theState == true then 
				(	
					spnSY.enabled=false
					spnSZ.enabled=false
				)
	        else
				(	
					spnSY.enabled=true
					spnSZ.enabled=true
				)
		)	
		
	on makeItSo pressed do
		(
			doLazyMap "randomize"
		)
		
		on btnResetGizmo pressed do
		(
		 doLazyMap "reset"
		)
		
		on btnQuickRotateX pressed do
		(
			doLazyMap "rotateX" 
		)
		
		on btnQuickRotateY pressed do
		(
			 doLazyMap "rotateY"
		)
		
		on btnQuickRotateZ pressed do
		(
			doLazyMap "rotateZ"
		)

		on btnAlignX pressed do
		(
			doLazyMap "alignX"
		)
		
		on btnAlignY pressed do
		(
			doLazyMap "alignY"
		)

		on btnAlignZ pressed do
		(
			doLazyMap "alignZ"
		)

		on btnRevertAll pressed do
		(
		doLazyMap "revert"
		)
		
		on btnDockLeft pressed do
		(
		cui.DockDialogBar LazyMap #cui_dock_left
		)
		
		on btnDockRight pressed do
		(
		cui.DockDialogBar LazyMap #cui_dock_right
		)
		
		on btnFloat pressed do
		(
		cui.FloatDialogBar LazyMap
		)
		
		on btnExit pressed do
		(
		cui.unRegisterDialogBar LazyMap
		DestroyDialog LazyMap
		)
)		




